#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int
main(int argc, char *argv[])
{
	int fd;
	unsigned char lo, hi;
	unsigned long val;

	if (argc != 2) {
		fprintf(stderr, "usage: %s < 'off' | 0-fff>\n", argv[0]);
		exit(1);
	}
	if (strcasecmp("off", argv[1]) == 0)
		val = 4095;
	else
		val = strtoul(argv[1], NULL, 16);

	if (val > 4095) {
		fprintf(stderr, "%s: %s: out of range\n", argv[0], argv[1]);
		exit(1);
	}
	lo = val & 0xff;
	hi = val >> 8;

	fd = open("/dev/port", O_WRONLY);
	if (fd == -1) {
		perror("open");
		exit(1);
	}
	if (lseek(fd, 0x8c1, SEEK_SET) == -1) {
		perror("lseek");
		exit(1);
	}
	if (write(fd, &hi, 1) != 1) {
		perror("write");
		exit(1);
	}
	if (lseek(fd, 0x8c0, SEEK_SET) == -1) {
		perror("lseek");
		exit(1);
	}
	if (write(fd, &lo, 1) != 1) {
		perror("write");
		exit(1);
	}

	return 0;
}

